import { Cell } from './cell';
export interface MutableArray<R> {
    length: number;
    setAt(index: number, value: R): void;
    push(...items: R[]): number;
    pop(): R | undefined;
    shift(): R | undefined;
    unshift(...items: R[]): number;
    splice(start: number, deleteCount?: number): R[];
    reverse(): R[];
}
export declare function mutArray<R>(initial: Array<R>): [Cell<R[]>, MutableArray<R>];
export interface MutableSet<T> {
    add(value: T): MutableSet<T>;
    delete(value: T): boolean;
    clear(): void;
}
export declare function mutSet<T>(initial?: Iterable<T>): [Cell<Set<T>>, MutableSet<T>];
export interface MutableMap<K, V> {
    set(key: K, value: V): this;
    delete(key: K): boolean;
    clear(): void;
}
export declare function mutMap<K, V>(initial?: Iterable<[K, V]>): [Cell<Map<K, V>>, MutableMap<K, V>];
