import type { Subscribable } from '../types';
import type { Runnable } from './types';
declare type Resolve<T> = T extends PromiseLike<infer P> ? P : T extends Subscribable<infer S> ? S : T extends Runnable<infer R> ? R : T;
declare type ResolveAll<T> = {
    [P in keyof T]: Resolve<T[P]>;
};
export declare function any<T>(tasks: Iterable<T>): Runnable<ResolveAll<T>>;
export declare function race<T>(tasks: Iterable<T>): Runnable<ResolveAll<T>>;
export declare function all<T>(tasks: Iterable<T>): Runnable<Resolve<T>[]>;
declare type TaskSettlement<T> = {
    status: 'fulfilled';
    value: T;
} | {
    status: 'rejected';
    reason?: any;
};
export declare function allSettled<T>(tasks: Iterable<T>): Runnable<TaskSettlement<Resolve<T>>[]>;
export {};
