import { Runnable, RunnableBlock, UnaryRunnableBlock, RunnableGenerator } from './types';
declare function _return<T>(value?: T): Runnable<never>;
declare function _break(label?: string): Runnable<never>;
declare function _continue(label?: string): Runnable<never>;
declare function _while(label: string, condition: () => any, block: RunnableBlock<void>): Runnable<void>;
declare function _while(condition: () => any, block: RunnableBlock<void>): Runnable<void>;
declare function _block(label: string, block: RunnableBlock<void>): Runnable<void>;
declare type SelectCase<T = any> = [
    Runnable<T>,
    ((payload: T) => Runnable<void>) | ((payload: T) => void)
];
declare class SelectBuilder implements Runnable<void> {
    protected readonly cases: SelectCase[];
    private readonly defaultCase?;
    constructor(cases: SelectCase[], defaultCase?: (() => Runnable<void> | void) | undefined);
    case<T>(awaited: any, block: UnaryRunnableBlock<void, T> | ((payload: T) => void)): SelectBuilder;
    [Symbol.iterator](): RunnableGenerator<void>;
}
declare class SelectBuilderWithDefault extends SelectBuilder {
    constructor(cases: SelectCase[]);
    case<T>(awaited: Runnable<T>, block: UnaryRunnableBlock<void, T> | ((payload: T) => void)): SelectBuilderWithDefault;
    default(block: RunnableBlock<void> | (() => void)): SelectBuilder;
}
export declare const ControlStatements: {
    break: typeof _break;
    continue: typeof _continue;
    return: typeof _return;
    while: typeof _while;
    loop: (block: RunnableBlock<void>) => Runnable<void>;
    block: typeof _block;
    select: SelectBuilderWithDefault;
};
export {};
