import { Cleanable } from '../types';
import { Runnable, RunnableGenerator } from './types';
export declare class AbortedError extends Error {
    name: string;
    constructor(message?: string);
}
export interface AbortablePromiseLike<T> extends PromiseLike<T> {
    abort(): void;
}
export declare class AbortablePromise<T> extends Promise<T> implements Runnable<T> {
    readonly abort: () => void;
    constructor(executor: (resolve: (value: T | PromiseLike<T>) => void, reject: (reason?: any) => void) => Cleanable);
    [Symbol.iterator](): RunnableGenerator<T>;
}
