import { Subscribable } from '../types';
import { AbortablePromise } from './promise';
import type { Runnable, TaskResult } from './types';
export declare class TaskSuspended {
    private readonly onAbort;
    private aborted;
    constructor(onAbort: () => void);
    abort(): void;
}
export declare function executeRunnableBlock<T>(block: Runnable<T>, asyncControlPoint?: (result: TaskResult) => void): TaskResult;
export declare function executeRunnableTask<T>(runnable: Runnable<T>, asyncControlPoint?: (result: TaskResult) => void): TaskResult;
export interface Task<T> extends AbortablePromise<T> {
}
declare type GeneratorReturnType<T> = T extends () => Runnable<infer R> ? R : undefined;
export declare function task<TaskFn extends (...args: any[]) => Runnable<any>>(taskFn: TaskFn): (...params: Parameters<TaskFn>) => Task<GeneratorReturnType<TaskFn>>;
export declare function delay(ms?: number): Runnable<void>;
export declare function timeout(ms?: number): Runnable<void>;
export declare function nextAnimationFrame(): Runnable<number>;
export declare function resolve<T>(value: T | Runnable<T> | PromiseLike<T> | Subscribable<T>): Runnable<T>;
export declare function __error(error: any): TaskResult;
export declare function __fulfill(value: any): TaskResult;
export declare function __return(value: any): TaskResult;
export declare function __break(): TaskResult;
export declare function __continue(): TaskResult;
export declare function __handle_task_complete(result: TaskResult): TaskResult;
export {};
