export declare type TaskYieldable = (asyncControlPoint: (result: TaskResult) => void) => TaskResult;
export declare type Runnable<T> = {
    [Symbol.iterator](): RunnableGenerator<T>;
};
export declare type RunnableGenerator<T> = Generator<TaskYieldable, T, any>;
export declare type RunnableBlock<T> = () => RunnableGenerator<T>;
export declare type UnaryRunnableBlock<T, Arg> = (payload: Arg) => RunnableGenerator<T>;
export declare type TaskResult = TaskFulfillResult | TaskErrorResult | TaskCompleteResult;
export declare type TaskFulfillResult = {
    type: 'fulfill';
    value: any;
};
export declare type TaskErrorResult = {
    type: 'error';
    error: any;
};
export declare type TaskCompleteResult = {
    type: 'complete';
    value?: any;
    completionType: CompletionType;
};
export declare const enum TaskResultType {
    Normal = 0,
    Error = 1,
    Complete = 2
}
export declare const enum CompletionType {
    Return = 1,
    Break = 2,
    Continue = 4
}
