declare type Identifier<T = unknown> = symbol & {
    _0: T;
};
declare const Identifier: {
    of: <T>(description: string, options?: {
        suggesstion?: string | undefined;
    } | undefined) => Identifier<T>;
};
declare class Context {
    private entries;
    constructor(entries?: Map<Identifier, any>);
    static EMPTY: Context;
    get<T>(token: Identifier<T>, options?: any): T;
    runInContext(): () => void;
    inherit(module: ConcernExport): Context;
    /**
     * Build a new context based on current from concern.
     * @param concern
     * @returns
     */
    build(concern: Concern): Context;
}
declare class IdentifierNotFoundError extends Error {
    readonly identifier: Identifier;
    constructor(identifier: Identifier);
}
declare type ConcernExport = NonNullable<object>;
declare function injected<T>(id: Identifier<T>, options?: {
    optional?: true;
    defaultValue: T;
}): T;
declare function injected<T>(id: Identifier<T>, options?: {
    optional?: true;
}): T | undefined;
declare function injected<T>(id: Identifier<T>, options?: {
    optional?: boolean;
}): T;
declare type Concern = () => ConcernExport | void;
declare type Concerns = Array<Concerns | Concern>;
declare function reduceConcerns(concerns: Concerns): Concern;
export { injected, reduceConcerns, Identifier, Context, Concern, Concerns, ConcernExport, IdentifierNotFoundError };
