import { EventStream } from './stream';
import { TeardownLogic } from './types';
interface Scheduler<T, R = T> {
    (next: (payload: R) => void): (payload: T) => void | TeardownLogic;
}
declare function debounce<T>(time: number): Scheduler<T>;
declare function throttle<T>(time: number): Scheduler<T>;
declare const animation: <T>(next: (payload: T) => void) => (payload: T) => () => void;
declare function scheduled<T, R = T>(source: EventStream<T>, scheduler: Scheduler<T, R>): EventStream<R>;
export { scheduled, Scheduler, debounce, throttle, animation };
