import type { RunnableGenerator } from './concurrency/types';
import { Cleanable, TeardownLogic } from './types';
export declare class EventStream<T> {
    private producer;
    constructor(producer: (next: (value: T) => void) => Cleanable);
    [Symbol.iterator](): RunnableGenerator<T>;
    private disposeProducer;
    private head;
    private tail;
    private propagating;
    private __internal_subscribe;
    private next;
    listen(handler: (value: T) => Cleanable): TeardownLogic;
    transform<R>(transformFn: (value: T) => R): EventStream<R>;
    filter(filterFn: (value: T) => boolean): EventStream<T>;
    static create<T>(): [EventStream<T>, (payload: T) => void];
}
export declare function stream<T = any>(): [EventStream<T>, (payload: T) => void];
export declare function never<T = never>(): EventStream<T>;
declare type ExtractEventStream<T> = {
    [P in keyof T]: T[P] extends EventStream<infer C> ? C : unknown;
};
export declare function merged<A extends Array<EventStream<any>>>(array: A): EventStream<ExtractEventStream<A>[number]>;
export {};
